use strict;

#Einbinden im Main.pl:
#      use webFrame::buildHTMLPAGE;

# Aufruf:
#     my $htmlPage = buildHTMLPage($datenFromMain);

###################################################################
###################################################################
## HTML Seite bauen - Tail

sub buildNormalTailPage
{
      my $result;
      $result .= "</body></html>\n";
      return($result);
}

###################################################################
###################################################################
## HTML Seite bauen - Head

sub buildNormalHeadPage
{
      ## bernahme der Parameter
      my ($CSSlocation, $title) = @_;
      
      my $result;
      $result .= "<html>\n";
      $result .= "<head>\n";
      $result .= "<title>$title</title>\n";
      $result .= "<link rel=\"stylesheet\" type=\"text/css\" href=\"$CSSlocation\">\n";
      $result .= "</head>\n";
      return($result);
}

###################################################################
###################################################################
## HTML Seite bauen - Parameter eintten
##
## setzt die Parameter sourcePage, login, sessionID, projekt
##

sub buildHTMLEnvPage
{
      ## bernahme der Parameter
      my ($datenForTheHTMLEnvString) = @_;
      
      ## Wandlung
      my %datenForTheHTMLEnv = %{$datenForTheHTMLEnvString};
      
      my $result = "\n\n";
      
      ## alle als InputField einpflegen
      foreach my $key (keys %datenForTheHTMLEnv)
      {$result .= "<input name=\"".$key."\" type=\"hidden\" size=\"70\" maxlength=\"70\" value=\"".$datenForTheHTMLEnv{$key}."\">\n";}
      
      $result .= "\n\n";
      
      return($result);
}


###################################################################
###################################################################
## HTML Seite bauen - Fehlerseite
## wird genutzt, wenn ein Fehler auftritt

sub buildNormalErrorHTMLPage
{
      ## bernahme der Parameter
      my ($errorMessage, $CSSlocation) = @_;
      
      my $result .= buildNormalHeadPage($CSSlocation, "WebFrame - Error");
      
      $result .= "<BODY BGCOLOR=ffffff>";
      $result .= "<h2>Ein Fehler ist aufgetreten</h2>\n";
      
      $result .= "<p>";
      $result .= "$errorMessage";
      $result .= "</p>";
      
      $result .= buildNormalTailPage();
      
      return($result);
}

###################################################################
###################################################################
## HTML Seite bauen - RettungsSeite
## wird genutzt, wenn keine andere Seite angezeigt werden wollte.

sub buildEmergencyHTMLPage
{
      ## bernahme der Parameter
      my ($useHTMLResponsePage, $CSSlocation) = @_;
           
      my $result .= buildNormalHeadPage($CSSlocation, "WebFrame - Emergency");
      
      $result .= "<BODY BGCOLOR=ffffff>";
      $result .= "<h1>ERROR</h1>\n";
      $result .= "<p>Ein Fehler ist aufgetreten. Wenn Sie diese Seite sehen knnen, wurde ";
      $result .= "das Programm schlecht programmiert, denn es wei nicht, welche Seite, Sie ";
      $result .= "sehen sollen. Sie drfen losgehen und den Programmierer schlagen.</p>";
      $result .= "<p>Ach ja, falls Sie ihm tatschlich begegnen sollten, knnen Sie ihm sagen ";
      $result .= "das zu der Funktion <u>buildHTMLPage</u> des Moduls <u>buildHTMLPage</u> kein bercksichtigter ";
      $result .= "Wert fr das Hash <u>datenFromMain</u> mit dem Key <u>useHTMLResponsePage</u> bergeben wurde.</p>";
      $result .= "<p>Aktuell hat dieser den Wert: <b>".$useHTMLResponsePage."</b></p>";
      $result .= "<p>Dieser Wert wird in dem SUB <u>main</u> des Scriptes <u>webFrameMain.pl</u> gesetzt.</p>";
      $result .= buildNormalTailPage();
      
      return($result);
}

###################################################################
###################################################################
## HTML Seite bauen - Admin Edit DB Page

sub buildAdminEditDBHTMLPage
{
      ## bernahme der Parameter
      my ($datenFromMainString) = @_;
      
      ## DatenFromMain auspacken (ist ja ein Hash)
      my %datenFromMainHASH = %{$datenFromMainString};
      my %datenFromHTTPHASH = %{$datenFromMainHASH{"datenFromHTTP"}};
      my %datenFromSUBMainHASH = %{$datenFromMainHASH{"datenFromSUBMain"}};
      my %datenFromConfigHASH = %{$datenFromMainHASH{"datenFromConfig"}};

      ## die Daten von der DB stecken als Hash in einem Array !!
      ## eine linearisierte Abfrage ist aber notwendig, deshalb werden die keys
      ## in ein Array gepackt, damit dieses spter zur Abfrage herangezogen werden kann.
      
      ## sinnloses parsen und freilegen des Arrays
      my @oldContentArray = @{$datenFromSUBMainHASH{"oldContent"}};
      
      ## jetzt ist es wichtig, um die Reihenfolge einhalten zu knnen,
      ## das das Hash "linearisiert" wird, d.h. erst einmal holen aller Keys in ein Array
      my %firstLineHash = %{$oldContentArray[0]};

      my @keyArray;
      
      ## bei obigen Vorgang ist noch zu erwhnen, das das erste Element immer die ID sein mu
      $keyArray[0] = "ID";
      
      ## da die ID nun in dem Array ist, knnen die Anderen in beliebiger Reihenfolge folgen
      foreach my $key (keys %firstLineHash){if($key ne "ID"){push(@keyArray, $key);}}
      
      ## Anfang mit der HTML Seite
      my $result .= buildNormalHeadPage($datenFromConfigHASH{"pfadCSS"}, "WebFrame - Edit DB");
      
      $result .= "<BODY BGCOLOR=ffffff>";
      $result .= "<h2>Admin Edit DB Page (".$datenFromSUBMainHASH{"nameOfDB2Edit"}.")</h2>\n";

      $result .= "<form action=\"../cgi-bin/webFrameMain.pl\" method=\"POST\" onSubmit=\"return confirm(\'Sollen die Daten so gespeichert werden?\')\">\n";

      $result .= "<table>\n";
      $result .= "<tr>\n";
      
      $result .= "<td>&nbsp;</td>\n";
      
      ## der Kopf
      foreach my $line (@keyArray){$result .= "<td class=\"head\"><b>$line</b></td>\n";}
      
      $result .= "</tr>\n";
      
      ## Ablauf aller Zeilen
      foreach my $line (@oldContentArray)
      {
            my %lineHash = %{$line};

            $result .= "<tr>\n";

            ## Jedes Element wird einzeln erwhnt
            foreach my $key (@keyArray)
            {
                  ## die angezeigte Lnge der Felder bestimmen
                  my $lengthForSize = length($lineHash{$key})+1;
                  
                  ## Wenn nichts drinsteht, dann Grundlnge
                  if($lengthForSize == 1){$lengthForSize=8;}
                  
                  ## die ID ist natrlich nicht editierbar
                  if($key eq "ID"){$result .= "<td class=\"head\">diese Zeile l&ouml;schen<input type=\"radio\" name=\"deleteThisLine\" value=\"$lineHash{$key}\"></td>\n"; $result .= "<td>$lineHash{$key}</td>\n";}
                  else
                  {
                        ## auch das PasswdFeld erfhrt eine spezielle Behandlung
                        if($key eq "passwd"){$result .= "<td><input name=\"save_".$lineHash{"ID"}."_$key\" type=\"password\" size=\"$lengthForSize\" maxlength=\"400\" value=\"$lineHash{$key}\"></td>\n";}
                        else
                        {$result .= "<td><input name=\"save_".$lineHash{"ID"}."_$key\" type=\"text\" size=\"$lengthForSize\" maxlength=\"400\" value=\"$lineHash{$key}\"></td>\n";}
                  }            
            }

            $result .= "</tr>\n";
      }
      
      $result .= "</table>\n";

      ## Neue Spalte
      $result .= "<p>Neue Spalte: <input name=\"newRow\" type=\"text\" size=\"20\" maxlength=\"400\" value=\"\"></p>\n";

      ## Neue Neue Zeile
      $result .= "<p>Neue Zeile:  (ja) <input name=\"newLine\" type=\"radio\" value=\"yes\"> &nbsp;&nbsp;&nbsp;(nein) <input name=\"newLine\" type=\"radio\" value=\"no\" checked></p>\n";


      ## Alles Speichern oder Reset
      $result .= "<p><input type=\"submit\" value=\" Alles Speichern \">&nbsp;&nbsp;&nbsp;<input type=\"reset\" value=\" Alles zur&uuml;ck setzen \"></p>\n";
      
      $result .= buildHTMLEnvPage($datenFromMainHASH{"datenForTheHTMLEnv"});

      $result .= "</form>\n";
      
      $result .= buildNormalTailPage();
      
      return($result);
}

###################################################################
###################################################################
## HTML Seite bauen - Admin Edit Config Page

sub buildAdminEditConfigHTMLPage
{
      ## bernahme der Parameter
      my ($datenFromMainString) = @_;
      
      ## DatenFromMain auspacken (ist ja ein Hash)
      my %datenFromMainHASH = %{$datenFromMainString};
      my %datenFromSUBMainHASH = %{$datenFromMainHASH{"datenFromSUBMain"}};
      my %datenFromConfigHASH = %{$datenFromMainHASH{"datenFromConfig"}};

      my $result .= buildNormalHeadPage($datenFromConfigHASH{"pfadCSS"}, "WebFrame - Edit Config");
      
      $result .= "<BODY BGCOLOR=ffffff>";
      $result .= "<h2>Admin Edit Config Page</h2>\n";

      $result .= "<form action=\"../cgi-bin/webFrameMain.pl\" method=\"POST\" onSubmit=\"return confirm(\'Sollen die Daten so gespeichert werden?\')\">\n";

      $result .= buildHTMLEnvPage($datenFromMainHASH{"datenForTheHTMLEnv"});

      $result .= "<table align=center>\n";

      ## Alle Parameter setzen
      foreach my $key (keys %datenFromConfigHASH)
      {$result .= "<tr><td>$key</td><td>&nbsp;&nbsp;&nbsp;</td><td><input name=\"".$key."\" type=\"text\" size=\"50\" maxlength=\"200\" value=\"".$datenFromConfigHASH{$key}."\"></td></tr>\n";}
      
      $result .= "<tr align=center><td colspan=3><p><input type=\"submit\" value=\" Speichern \">&nbsp;&nbsp;&nbsp;<input type=\"reset\" value=\" Zur&uuml;ck setzen \"></p></td></tr>\n";

      $result .= "</table><br><br>\n";
      
      $result .= "</form>\n";
      
      $result .= buildNormalTailPage();
      
      return($result);
      
}

###################################################################
###################################################################
## HTML Seite bauen - Admin Main Page

sub buildAdminMainHTMLPage
{
      ## bernahme der Parameter
      my ($datenFromMainString) = @_;
      
      ## DatenFromMain auspacken (ist ja ein Hash)
      my %datenFromMainHASH = %{$datenFromMainString};
      my %datenFromConfigHASH = %{$datenFromMainHASH{"datenFromConfig"}};
            
      my $result .= buildNormalHeadPage($datenFromConfigHASH{"pfadCSS"}, "WebFrame - Admin Main");
      
      $result .= "<BODY BGCOLOR=ffffff>";
      $result .= "<h2>Admin Main Page</h2>\n";
      
      $result .= "<p>Bitte whlen Sie eine Option aus:</p>";
      
      $result .= "<form action=\"../cgi-bin/webFrameMain.pl\" method=\"POST\">\n";
      
      $result .= buildHTMLEnvPage($datenFromMainHASH{"datenForTheHTMLEnv"});
      
      $result .= "<table>\n";
      $result .= "<tr><td><input type=\"radio\" name=\"editSomething\" value=\"config\"></td><td>Editieren der Konfigurationsdatei</td></tr>\n";
      $result .= "<tr><td><input type=\"radio\" name=\"editSomething\" value=\"user.db\"></td><td>Editieren der Userdatei<td></td></tr>\n";
      $result .= "</table><br><br>\n";
      
      $result .= "<input type=\"submit\" value=\" Ausw&auml;hlen \">\n";
      
      $result .= "</form>\n";
      
      $result .= buildNormalTailPage();
      
      return($result);
}


###################################################################
###################################################################
## HTML Seite bauen - Analyse Seite

sub buildAnalyseHTMLPage
{
      ## bernahme der Parameter
      my ($datenFromMainString, $CSSlocation) = @_;
      
      ## Auspacken
      my %datenFromMain = %{$datenFromMainString};
      
      ## Kopfelemente bauen
      my $result .= buildNormalHeadPage($CSSlocation, "WebFrame - Analyse");

      $result .= "<BODY BGCOLOR=ffffff>";
      
      my %tmpHash;

      ## Fr jedes Element des Hashes
      foreach my $keyMain (keys %datenFromMain)
      {
            ## Welche Datengruppe?
            $result .= "<h3>".$keyMain."</h3>\n";
            
            ## Diese besteht aus Elementen
            %tmpHash = %{$datenFromMain{$keyMain}};
      
            $result .= "<table>\n";
            
            ## Jedes Element wird einzeln erwhnt
            foreach my $key (keys %tmpHash)
            {$result .= "<tr><td>(".$key.")</td><td>[<u>$tmpHash{$key}</u>]</td></tr>\n";}
            
            $result .= "</table>\n";
      }

      ## Ende bauen      
      $result .= buildNormalTailPage();
      
      return($result);
}

      

###################################################################
###################################################################
## HTML Seite bauen - Main Seite

sub buildHTMLPage
{
      ## bernahme der Parameter
      my ($datenFromMainString) = @_;
      
      ## Auspacken
      my %datenFromMain = %{$datenFromMainString};
      
      ## erhalten, welche Seite angezeigt werden soll:
      my $datenFromSUBMainString = $datenFromMain{"datenFromSUBMain"};
      my %datenFromSUBMain = %{$datenFromSUBMainString};
      
      ## wo ist das CSS?
      my $datenFromConfigString = $datenFromMain{"datenFromConfig"};
      my %datenFromConfigHash = %{$datenFromConfigString};
      
      my $result;

      ####################################
      ##
      ## Nachfolgend knnen die einzelnen, fr die Applikation bentigten Seiten
      ## eingepflegt werden. Einige Beispielsseiten sind bereits enthalten.
      ##
      ##  ||
      ##  \/
      ##
      ####################################

      ## AdminSeite: 
      if($datenFromSUBMain{"useHTMLResponsePage"} eq "AdminMainPage"){$result = buildAdminMainHTMLPage($datenFromMainString);}
      
      ## AdminEditConfigPage
      if($datenFromSUBMain{"useHTMLResponsePage"} eq "AdminEditConfigPage"){$result = buildAdminEditConfigHTMLPage($datenFromMainString);}

      ## AdminEditDBPage
      if($datenFromSUBMain{"useHTMLResponsePage"} eq "AdminEditDBPage"){$result = buildAdminEditDBHTMLPage($datenFromMainString);}
      
      ## AllgemeineFehlerSeite:
      if($datenFromSUBMain{"useHTMLResponsePage"} eq "normalErrorPage")
      {$result = buildNormalErrorHTMLPage($datenFromSUBMain{"errorMessage"}, $datenFromConfigHash{"pfadCSS"});}
            
      ## Die AnalyseSeite:
      if($datenFromSUBMain{"useHTMLResponsePage"} eq "Analyse")
      {$result = buildAnalyseHTMLPage($datenFromMainString, $datenFromConfigHash{"pfadCSS"});}
      
      ## Die RettungsSeite (wird angezeigt, wenn nix anderes passt)
      if($result eq ""){$result = buildEmergencyHTMLPage($datenFromSUBMain{"useHTMLResponsePage"}, $datenFromConfigHash{"pfadCSS"});}
      
      ####################################
      ##
      ##  /\ 
      ##  ||
      ##
      ## Der Rest sollte wieder unangetastet bleiben.
      ##
      ####################################
      
      return($result);
      
}

1;