use strict;

#Einbinden im Main.pl:
#      use webFrame::fileOperation;

#Einlesen in ein Hash:
#my $datenFromConfig = readDataFromFileHASH(\%datenFromHTTP); 
#my $resultHash = readDataFromCFGFile("./webFrame/$projektPath/",$projektFile);
#my $allDataFromUserDBString = readDataFromDBFile("./webFrame/$projekt/",$file);

###################################################################
###################################################################
## Im Gegensatz zu writeData2FileHTTP mssen hier die Zugriffe
## selber genutzt werden. NEIN, das Einlesen des DB Files passiert
## noch mit der Funktion: readDataFromDBFile
sub writeData2DBFileHTTP
{
      ## bernahme der Parameter
      my ($datenFromHTTPString, $cryptPasswd) = @_;
      
      ## ACHTUNG ! fr Felder mit Passwd mu eine spezielle Behandlung her!
      ## Dieser werden unter Umstnden verschlsselt abgelegt, d.h. in
      ## der DB steht der verschlsselte Wert, von der Oberflche kommt
      ## einmal der verschlsselte, einmal der nicht verschlsselte Wert
      
      ## des weiteren knnen nicht zwei ;; abgespeichert werden, da diese
      ## ja gerade die Trennung in dem DB-File darstellen.
      
      ## und wenn wir schon mal dabei sind, zwei identische LoginNames sind
      ## auch nicht zulssig.
      
      ## Auspacken
      my %datenFromHTTP = %{$datenFromHTTPString};
      
      ## wie heit das File?
      my $projektFile = $datenFromHTTP{"nameOfDB2Edit"};
      
      ## wie heit der Pfad?
      my $projektPath = $datenFromHTTP{"projekt"};
      
      ######
      ## Reihenfolge der Ttigkeiten
      ##  Daten von HTML aufdrseln       ok
      ##  Daten aus Datei lesen           ok
      ##  alle nderungen bernehmen      ok
      ##  Zeile lschen
      ##  neue Spalte
      ##  neue Zeile
      ##  alles wieder speichern          in Arbeit
      
      ## Zieldatenstruktur ist ein Hash mit Hashes
      my %hashOfLinesHTML;
      
      #### ERHALTENE DATEN AUFDRSELN
      foreach my $key (keys %datenFromHTTP)
      {
            my $value = $datenFromHTTP{$key};
            
            ## von der Oberflche gibts da vielleicht doch noch ein Problem
            ## etwaige + werden in Space gewandelt
            $value =~ s/\+/\ /g;
            ## gibts irgendwo zwei ;; werden diese zu einem ; gewandelt
            $value =~ s/\;\;/\;/g;
            
            ## ein Parameter mit save am Anfang?
            if($key =~ m/^save/ )
            {
                  ## ein SaveField ist wiefolgt aufgebaut: (z.B.)
                  ## (save_1_login) => 0=save, 1=1, 2=login
                  ## also mu es aufgedrselt werden
                  my @splitKeys = split(/\_/, $key);
                  
                  ## Zeilennummer nutzen fr das richtige Feld im Hash
                  my $tmpHashString = $hashOfLinesHTML{$splitKeys[1]};

                  my %tmpHash;
                  
                  ## Stand da schon was drin? wenn ja, Inhalt rauskopieren
                  if($tmpHashString ne ""){%tmpHash = %{$tmpHashString}}
                  
                  ## key nutzen fr das Hash
                  $tmpHash{$splitKeys[2]} = $value;
                  
                  ## und wieder zurck ins Array
                  $hashOfLinesHTML{$splitKeys[1]} = \%tmpHash;
            }
      }
      
      ## Die neuen Daten stehen nun in dem Array
      
      #### DB EINLESEN

      ## andere Methode nutzen, das Ergebniss ist ein Array (gefllt mit Hashes) in Form
      ## eines Strings
      my $arrayOfLinesDBString = readDataFromDBFile("./webFrame/$projektPath/",$projektFile); # use webFrame:fileOperation
      my @arrayOfLinesDB = @{$arrayOfLinesDBString};

      #### HTML mit DB VERGLEICHEN, DB notfalls ndern

      ## DB File gibt vor:
      for(my $i=0; $i<length(@arrayOfLinesDB); $i++)
      {
            my $singleLineHASHDBString = $arrayOfLinesDB[$i];
            my %singleLineHASHDB = %{$singleLineHASHDBString};
            
            ## richtige HTML Line holen (anhand der ID)
            my $singleLineHASHHTMLString = $hashOfLinesHTML{$singleLineHASHDB{"ID"}};
            my %singleLineHASHHTML = %{$singleLineHASHHTMLString};
            
            ## und nun, lets Rock, jeden Value vergleichen
            foreach my $key (keys %singleLineHASHDB)
            {
                  ## alle Werte knnen erst einmal bernommen werden (auer natrlich Passwd)
                  if($key eq "passwd" && $cryptPasswd == 1 && $singleLineHASHDB{$key} ne $singleLineHASHHTML{$key})
                  {
                        ## Passwort und aktiviert
                        $singleLineHASHDB{$key} = ownCrypt($singleLineHASHHTML{$key}); # use webFrame:utility
                        
                        die printERRORPage("$singleLineHASHDB{$key}");
                  }
                  ## alles andere
                  else{$singleLineHASHDB{$key} = $singleLineHASHHTML{$key};}
            }
      }

      #### DB WIEDER SPEICHERN
      createDBFileA("./webFrame/$projektPath/",$projektFile,\@arrayOfLinesDB);
      
      return();
}

###################################################################
###################################################################
## Erwartet den Pfad, den Filenamen und ein String, in dem ein
## Array (der einzelnen Zeilen, ohne Kopfzeile) steht, die Zeilen
## sind als Hash eingebunden.
sub createDBFileA
{
      ## bernahme der Parameter
      my ($path, $file, $arrayOfLinesDBString) = @_;
      
      ## erst einmal sinnloses parsen:
      my @arrayOfLinesDB = @{$arrayOfLinesDBString};
      
      return();
}

###################################################################
###################################################################
## Da so viele ja nicht auf die CFG Datei zugreifen drften und alle
## anderen Informationen in DB Dateien stehen, werden zum Auslesen
## die bereits bekannten Methoden genutzt
sub writeData2FileHTTP
{
      ## bernahme der Parameter
      my ($datenFromHTTPString) = @_;
      
      ## Auspacken
      my %datenFromHTTP = %{$datenFromHTTPString};
      
      ## wie heit das File?
      my $projektFile = $datenFromHTTP{"projekt"}.".cfg";
      
      ## wie heit der Pfad?
      my $projektPath = $datenFromHTTP{"projekt"};
      
      ## Inhalt der Datei
      my $alterInhaltString = readDataFromCFGFile("./webFrame/$projektPath/",$projektFile);
      my %alterInhalt = %{$alterInhaltString};
      
	# File schreibend ffnen
	open(DATEI, "> ./webFrame/$projektPath/"."$projektFile") or die printERRORPage("Es wurde versucht das File ./webFrame/$projektPath/"."$projektFile zu ffnen. Das gelang nicht. Ort: webFrame::fileOperation writeData2FileHTTP"); ## webFrameMain.pl
      
      ## jedes Name:Value Pair schreiben
      foreach my $key (keys %alterInhalt){print DATEI "$key : $datenFromHTTP{$key}\n";}
      
      #Schlieen dieser Datei
      close(DATEI);

      return();
}

###################################################################
###################################################################
## bergeordnete Methode, macht nix anderes, als die Parameter von 
## webFrameMain.pl aufzudrseln und die eigentlich wichtige Methode
## aufzurufen

sub readDataFromFileHTTP
{
      ## bernahme der Parameter
      my ($datenFromHTTPString) = @_;
      
      ## Auspacken
      my %datenFromHTTP = %{$datenFromHTTPString};
      
      ## wie heit das File?
      my $projektFile = $datenFromHTTP{"projekt"}.".cfg";
      
      ## wie heit der Pfad?
      my $projektPath = $datenFromHTTP{"projekt"};
      
      my $resultHash = readDataFromCFGFile("./webFrame/$projektPath/",$projektFile);
      
      return($resultHash);
}

###################################################################
###################################################################
## Liest ein File aus, bergibt alle Zeilen in Form eines Arrays zurck.
## Diese Methode ist nur bedingt nutzbar! Soll ein Schreibproze auch
## zugreifen, empfiehlt sie sich nicht, da das File zwischenzeitlich
## fr andere Prozesse offen ist.

sub readDataFromFile
{
      ## bernahme der Parameter
      my ($path, $file) = @_;
      
	# File auslesen
	open(DATEI, "< $path"."$file") or die printERRORPage("Es wurde versucht das File $path"."$file zu ffnen. Das gelang nicht. Ort: webFrame::fileOperation readDataFromFile"); ## webFrameMain.pl
      
      #Einlesen dieser Datei
      my @InhaltDatei = <DATEI>;
      
      #Schlieen dieser Datei
      close(DATEI);

      ## Von jeder Zeile das ZeilenendeZeichen entfernen
      for (my $i=0; $i<@InhaltDatei; $i++){chomp($InhaltDatei[$i]);}
      
      ## Rckgabe des Inhaltes
      return(\@InhaltDatei);
}

###################################################################
###################################################################
## Diese Methode schreibt ein einzelnes Datum in ein File.
sub writeSingleDataToFile
{
      ## bernahme der Parameter
      my ($path, $file, $id, $name, $newValue) = @_;
      
	# File auslesen
	open(DATEI, "< $path"."$file") or die printERRORPage("Es wurde versucht das File $path"."$file zu ffnen. Das gelang nicht. Ort: webFrame::fileOperation writeSingleDataToFile"); ## webFrameMain.pl
      
      #Einlesen dieser Datei
      my @InhaltDatei = <DATEI>;
      
      #Schlieen dieser Datei
      close(DATEI);
      
      ## Von jeder Zeile das ZeilenendeZeichen entfernen
      for (my $i=0; $i<@InhaltDatei; $i++){chomp($InhaltDatei[$i]);}
      
      
      ## Kopfzeile entfernen.
      ## Die Kopfzeile bezeichnet auch gleichzeitig die einzelnen Elemente 
      my $headLine = shift(@InhaltDatei);

      ## KopfZeile aufdrseln
      my @KopfZeileData = split(/;;/, $headLine);
      
      my $indexGesuchteElement = -1;
      
      ## an welcher Stelle soll der Werte gendert werden?
      for (my $i=0; $i<@KopfZeileData; $i++)
      {if($KopfZeileData[$i] eq $name){$indexGesuchteElement= $i;}}
      
      ## gibt es dieses Element ?
      if($indexGesuchteElement == -1){die printERRORPage("Es wurde versucht in der Datei $file den Parameter $name zu ndern, den es dort nicht gibt. Ort: webFrame::fileOperation writeSingleDataToFile");} ## webFrameMain.pl
      
      my $returnValue;
      
      my $changed = 0;
      
      ## den richtigen Eintrag suchen
      for (my $i=0; $i<@InhaltDatei; $i++)
      {
            ## wildes zerlegen
            my @zeileArray = split(/;;/, $InhaltDatei[$i]);
            
            ## die id befindet sich in der ersten Spalte, danach gesucht und den Wert ndern
            if($id eq $zeileArray[0])
            {$zeileArray[$indexGesuchteElement] = $newValue; $changed=1;}
            
            ## wildes zusammenfgen, aber nur, wenn etwas gendert wurde
            if($changed == 1)
            {
                  ## bisherige Zeile leeren
                  $InhaltDatei[$i] = "";
                  
                  ## jeden Wert einzeln, mit ;; separiert anfgen
                  foreach my $singleValue (@zeileArray)
                  {$InhaltDatei[$i] .= $singleValue.";;";}

                  $returnValue = $InhaltDatei[$i];
                  
                  ## und am Ende Abbruch
                  last;
            }
      }
      
      ## wenn etwas gendert wurde, mu alles neu gespeichert werden.
      if($changed == 1)
      {
            #Kopfzeile wieder anfgen
            unshift(@InhaltDatei, $headLine);
            
      	# File schreibend ffnen
      	open(DATEI, "> $path"."$file") or die printERRORPage("Es wurde versucht das File $path"."$file schreibend zu ffnen. Das gelang nicht. Ort: webFrame::fileOperation writeSingleDataToFile"); ## webFrameMain.pl
            
            ## jede Zeile schreiben
            foreach my $line (@InhaltDatei)
            {print DATEI $line."\n";}
            
            #Schlieen dieser Datei
            close(DATEI);
      
      }
      
      
      return();
}

###################################################################
###################################################################
## Liest die Daten aus einem File aus. Erwartet in diesem eine Headline.
## Die einzelnen Parameter mssen per ;; getrennt sein. Gibt ein Array von
## Hashes zurck.
sub readDataFromDBFile
{
      ## bernahme der Parameter
      my ($path, $file) = @_;
      
      #Einlesen dieser Datei
      my $InhaltDateiString = readDataFromFile($path, $file);

      ## Aus String mach Array
      my @InhaltDatei = @{$InhaltDateiString};

      ## Kopfzeile entfernen.
      ## Die Kopfzeile bezeichnet auch gleichzeitig die Elemente des Hashes
      my $headLine = shift(@InhaltDatei);

      my @resultArray;
      
      ## KopfZeile aufdrseln
      my @KopfZeileData = split(/;;/, $headLine);
      
      ## die verbliebenen Zeilen aufdrseln, jeweils in ein Hash packen und
      ## dieses als String in ein Array.
      my $count=0;
      foreach my $userLine (@InhaltDatei)
      {
            my %tmpHASH;
            $count++;
            my @lineArray = split(/;;/, $userLine);
            
            ## alle Parameter in das Hash
            for(my $i=0; $i<@KopfZeileData; $i++)
            {if($KopfZeileData[$i] ne ""){$tmpHASH{$KopfZeileData[$i]} = $lineArray[$i];}}
            
            ## das Hash als String ins Array
            push(@resultArray, \%tmpHASH);
      }

      testPrintArray2Hash(\@resultArray); # use webFrame:utitlity;

      ## Array bergeben (als String)
      return(\@resultArray);
}

###################################################################
###################################################################
## Eine Zeile wird an ein File angehngt, dient z.B. fr Protokolle

sub appendLine2File
{
      ## bernahme der Parameter
      my ($path, $file, $line) = @_;
      
      ## Returns entfernen.
      chomp($line);
      
	# File anhngend ffnen
	open(DATEI, ">> $path"."$file") or die printERRORPage("Es wurde versucht das File $path"."$file anhngend zu ffnen. Das gelang nicht. Ort: webFrame::fileOperation appendLine2File"); ## webFrameMain.pl
      
      ## schreiben
      print DATEI $line."\n";
      
      #Schlieen dieser Datei
      close(DATEI);
      
      return();
}

###################################################################
###################################################################
## Erhlt path und filename. ffnet die angegebene Datei. Erwartet
## name:value pairs. Packt diese in einen Hash.

sub readDataFromCFGFile
{
      ## bernahme der Parameter
      my ($path, $file) = @_;
      
      #Einlesen dieser Datei
      my $InhaltKonfigDateiString = readDataFromFile($path, $file);

      my @InhaltKonfigDatei = @{$InhaltKonfigDateiString};
      
      my %resultHASH;
      
      #Verarbeiten der Zeilen
      foreach my $line (@InhaltKonfigDatei)
      {
            chomp($line);

            #falls DOS: Steuerzeichen raus:
            $line =~ s/\W$//g;
            
            #Kommentare raus
            if($line =~ m/^\#/ ){next;}
            
            #enthlt diese Zeile einen Doppelpunkt?
            if($line =~ m/\:/g )
            {
                  my ($content, $value) = split(/:/,$line);

                  #Leerzeichen am Anfang weg
                  $value =~ s/^\ +//g;
                  $content =~ s/^\ +//g;
                  
                  #Leerzeichen am Ende weg
                  $value =~ s/\s+$//g;
                  $content =~ s/\s+$//g;
                  
                  #ins Hash einbauen
                  $resultHASH{$content} = $value;
            }
      }
      
      return(\%resultHASH);     
}

1;