use strict;

#Einbinden im Main.pl:
#      use webFrame::userHandling;

###################################################################
###################################################################
## Erstellen des Session Log
sub writeSessionLog
{
      ## bernahme der Parameter
      my ($projekt, $file, $login, $ip, $timeStamp, $angemeldet, $action, $sourcePage ) = @_;

      my $line = "$login ($ip): $timeStamp  angemeldet($angemeldet) action($action) von $sourcePage";
      
      ## anhngen
      appendLine2File("./webFrame/$projekt/",$file, $line); # use webFrame::fileOperation
      
      return();
}

###################################################################
###################################################################
## 
sub getUserDataLOGIN
{
      ## bernahme der Parameter
      my ($login, $file, $projekt) = @_;

      ## bergabe des Files und Pfades, erhalten des Arrays mit allen Benutzern
      my $allDataFromUserDBString = readDataFromDBFile("./webFrame/$projekt/",$file); # use webFrame::fileOperation;
      
      ## falls es diesen User nicht gibt, wird "no" bermittelt
      my $result = "no";
      
      ## Aus String mach Array
      my @allDataFromUserDB = @{$allDataFromUserDBString};
      
      ## fr jede Zeile wird jetzt geprft, ob das Login existiert
      ## taucht das Login doppelt auf, wird das letzte genommen
      foreach my $userLineString(@allDataFromUserDB)
      {
            ## String 2 Hash
            my %userLineHash = %{$userLineString};
            
            ## taucht das Login hier auf?
            if($userLineHash{"login"} eq $login)
            {$result = $userLineString;}
      }
      return($result);      
}

###################################################################
###################################################################
## Setzt die SessionID anhand der userID und gibt diese auch zurck.

sub setSessionID
{
      ## bernahme der Parameter
      my ($userID, $file, $projekt, $lengthSessionID) = @_;
      
      ## neue SessionID holen
      my $newSessionID = generateSessionID($lengthSessionID); # use webFrame::utility;
      
      ## diese ins File schreiben
      writeSingleDataToFile("./webFrame/$projekt/",$file,$userID,"sessionID", $newSessionID); # use webFrame::fileOperation;
      
      ## und auch zurckgeben
      return($newSessionID);
}

###################################################################
###################################################################
## Setzt fr einen User den TimeStamp anhand der userID

sub setTimeStamp
{
      ## bernahme der Parameter
      my ($userID, $file, $projekt) = @_;
      
      ## TimeStamp generieren
      my $newTimeStamp = generateFormatTimeStamp(); # use webFrame:utility;

      ## diesen ins File schreiben
      writeSingleDataToFile("./webFrame/$projekt/",$file,$userID,"timeStamp", $newTimeStamp); # use webFrame::fileOperation;

      return();
}

1;