use strict;

#Einbinden im Main.pl:
#      use webFrame::utility;

###################################################################
###################################################################
## Generate TimeStamp in dem Format: tt.mm.JJJJ hh:mm:ss

sub generateFormatTimeStamp
{
      my ($Sekunden, $Minuten, $Stunden, $Monatstag, $Monat, $Jahr) = localtime(time); 
      $Jahr+=1900;
      $Monat+=1;

      my $sekParse;
      my $minParse;
      my $stdParse;
      my $mTagParse;
      my $motParse;
      
      if($Sekunden <= 9){$sekParse="0";}
      if($Minuten <= 9){$minParse="0";}
      if($Stunden <= 9){$stdParse="0";}
      if($Monatstag <= 9){$mTagParse="0";}
      if($Monat <= 9){$motParse="0";}
      
      return("$mTagParse"."$Monatstag.$motParse"."$Monat.$Jahr $stdParse"."$Stunden:$minParse"."$Minuten:$sekParse"."$Sekunden");
}


###################################################################
###################################################################
## Generate sessionID

sub generateSessionID
{
      ## bernahme der Parameter
      my ($lengthsessionID) = @_;
      
      ## die Lnge der sessionID ist beschrnkt, sie sollte zwischen
      ## 5 und 50 liegen.
      if($lengthsessionID < 5){$lengthsessionID=5;}
      if($lengthsessionID > 50){$lengthsessionID=50;}
      
      my $generatedID;
      
      ## alle Stellen generieren.
      for(my $i=0; $i<$lengthsessionID; $i++)
      {
            ## Was soll genommen werden? Zahlen (1), Groe Buchstaben (2)
            ## oder kleine Buchstaben(3) ??
            my $suffi_a = zufall(1,3);
            
            ## Zahlen
            if($suffi_a == 1){$generatedID .= chr(zufall(48,57));}

            ## Grobuchstaben
            if($suffi_a == 2){$generatedID .= chr(zufall(65,90));}
      
            ## Kleinbuchstaben
            if($suffi_a == 3){$generatedID .= chr(zufall(97,122));}
      }
      
      return($generatedID);
}

###################################################################
###################################################################
## Zufallsgenerator
## produziert gleichverteilt Zufallszahlen in dem
## diskreten Raum: [$start,...,$end] dabei gilt
## insbesondere nicht: [$start,...,$end[ oder
## ]$start,...,$end]

sub zufall
{
      ## bernahme der Parameter
      my ($start, $end) = @_;

      my $suffi = int(rand($end-$start+1))+$start;

      return($suffi);
}

###################################################################
###################################################################
## eigene Verschlsselung, notwendig, da Sonderzeichen nicht erlaubt
sub ownCrypt
{
      my($plaintext) = @_;

      my $chiffre = crypt($plaintext, "EigenesSalz");

      ## Sonderzeichen ersetzen
      $chiffre =~ s/\W/t/g;

      return($chiffre);
}

###################################################################
###################################################################
## fr Testzwecke: Ausgabe der Datenstruktur, wenn in einem Array
## pro Element ein Hash steckt.
sub testPrintArray2Hash
{
      # Parameter einlesen
      my ($arrayOfLinesString) = @_;
      my @arrayOfLines = @{$arrayOfLinesString};
      
      my $test = "DB: Lnge:".length(@arrayOfLines)."<br>";
      
      for (my $i=0; $i<length(@arrayOfLines); $i++)
      {
           my %singleLineB = %{$arrayOfLines[$i]};     
           $test .= "<br> $i";
           foreach my $key2 (keys %singleLineB)
           {$test .= " $key2:".$singleLineB{$key2}."  ";}
     }
     die printERRORPage("$test");
}

###################################################################
###################################################################
## fr Testzwecke: Ausgabe der Datenstruktur, wenn in einem Hash
## pro Element ein Hash steckt.
sub testPrintHash2Hash
{
      # Parameter einlesen
      my ($hashOfLinesString) = @_;
      my %hashOfLines = %{$hashOfLinesString};
      
      my $test = "DB: <br>";
      
      foreach my $key (keys %hashOfLines)
      {
           my %singleLineB = %{$hashOfLines{$key}};     
           $test .= "<br> $key";
           foreach my $key2 (keys %singleLineB)
           {$test .= " $key2:".$singleLineB{$key2}."  ";}
     }
     die printERRORPage("$test");
}

1;